<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: examplePredictAndTrack.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('examplePredictAndTrack_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">examplePredictAndTrack.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example predicts the trajectory to swing a double pendulum from horizontal to vertical, and then tracks the resulting trajectory.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># OpenSim Moco: examplePredictAndTrack.py                                    #</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright (c) 2018 Stanford University and the Authors                     #</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Author(s): Christopher Dembia                                              #</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    #</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"># not use this file except in compliance with the License. You may obtain a  #</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># copy of the License at http://www.apache.org/licenses/LICENSE-2.0          #</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software        #</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          #</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and        #</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.                                             #</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">import</span> math</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="stringliteral">&quot;&quot;&quot;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="stringliteral">This file performs the following problems using a</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="stringliteral">double pendulum model:</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="stringliteral"></span> </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="stringliteral">    1. predict an optimal trajectory (and controls),</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="stringliteral">    2. track the states from the optimal trajectory, and</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="stringliteral">    3. track the marker trajectories from the optimal trajectory.</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="stringliteral"></span> </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="stringliteral">&quot;&quot;&quot;</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;visualize = <span class="keyword">True</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"># The following environment variable is set during automated testing.</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keywordflow">if</span> os.getenv(<span class="stringliteral">&#39;OPENSIM_USE_VISUALIZER&#39;</span>) == <span class="stringliteral">&#39;0&#39;</span>:</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    visualize = <span class="keyword">False</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"># Create a model of a double pendulum.</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment"># ------------------------------------</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">def </span>createDoublePendulumModel():</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    model = osim.Model()</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    model.setName(<span class="stringliteral">&quot;double_pendulum&quot;</span>)</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="comment"># Create two links, each with a mass of 1 kg, center of mass at the body&#39;s</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="comment"># origin, and moments and products of inertia of zero.</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    b0 = osim.Body(<span class="stringliteral">&quot;b0&quot;</span>, 1, osim.Vec3(0), osim.Inertia(1))</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    model.addBody(b0)</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    b1 = osim.Body(<span class="stringliteral">&quot;b1&quot;</span>, 1, osim.Vec3(0), osim.Inertia(1))</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    model.addBody(b1)</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="comment"># Add markers to body origin locations.</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    m0 = osim.Marker(<span class="stringliteral">&quot;m0&quot;</span>, b0, osim.Vec3(0))</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    m1 = osim.Marker(<span class="stringliteral">&quot;m1&quot;</span>, b1, osim.Vec3(0))</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    model.addMarker(m0)</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    model.addMarker(m1)</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="comment"># Connect the bodies with pin joints. Assume each body is 1 m long.</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    j0 = osim.PinJoint(<span class="stringliteral">&quot;j0&quot;</span>, model.getGround(), osim.Vec3(0), osim.Vec3(0),</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        b0, osim.Vec3(-1, 0, 0), osim.Vec3(0))</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    q0 = j0.updCoordinate()</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    q0.setName(<span class="stringliteral">&quot;q0&quot;</span>)</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    j1 = osim.PinJoint(<span class="stringliteral">&quot;j1&quot;</span>,</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        b0, osim.Vec3(0), osim.Vec3(0), b1, osim.Vec3(-1, 0, 0), osim.Vec3(0))</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    q1 = j1.updCoordinate()</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    q1.setName(<span class="stringliteral">&quot;q1&quot;</span>)</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    model.addJoint(j0)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    model.addJoint(j1)</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    tau0 = osim.CoordinateActuator()</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    tau0.setCoordinate(j0.updCoordinate())</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    tau0.setName(<span class="stringliteral">&quot;tau0&quot;</span>)</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    tau0.setOptimalForce(1)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    model.addComponent(tau0)</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    tau1 = osim.CoordinateActuator()</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    tau1.setCoordinate(j1.updCoordinate())</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    tau1.setName(<span class="stringliteral">&quot;tau1&quot;</span>)</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    tau1.setOptimalForce(1)</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    model.addComponent(tau1)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="comment"># Add display geometry.</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    bodyGeometry = osim.Ellipsoid(0.5, 0.1, 0.1)</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    transform = osim.Transform(osim.Vec3(-0.5, 0, 0))</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    b0Center = osim.PhysicalOffsetFrame(<span class="stringliteral">&quot;b0_center&quot;</span>, b0, transform)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    b0.addComponent(b0Center)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    b0Center.attachGeometry(bodyGeometry.clone())</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    b1Center = osim.PhysicalOffsetFrame(<span class="stringliteral">&quot;b1_center&quot;</span>, b1, transform)</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    b1.addComponent(b1Center)</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    b1Center.attachGeometry(bodyGeometry.clone())</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    model.finalizeConnections()</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    model.printToXML(<span class="stringliteral">&quot;double_pendulum.osim&quot;</span>)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordflow">return</span> model</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">def </span>solvePrediction():</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="comment"># Predict the optimal trajectory for a minimum time swing-up.</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="comment"># In the diagram below, + represents the origin, and ---o represents a link</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="comment"># in the double pendulum.</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="comment">#</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="comment">#                              o</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="comment">#                              |</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="comment">#                              o</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="comment">#                              |</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="comment">#         +---o---o            +</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="comment">#</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="comment">#       iniital pose      final pose</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="comment">#</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    study = osim.MocoStudy()</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    study.setName(<span class="stringliteral">&quot;double_pendulum_predict&quot;</span>)</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    problem = study.updProblem()</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160; </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="comment"># Model (dynamics).</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    problem.setModel(createDoublePendulumModel())</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="comment"># Bounds.</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    problem.setTimeBounds(0, [0, 5])</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment"># Arguments are name, [lower bound, upper bound],</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="comment">#                     initial [lower bound, upper bound],</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="comment">#                     final [lower bound, upper bound].</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/value&quot;</span>, [-10, 10], 0)</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/speed&quot;</span>, [-50, 50], 0, 0)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/value&quot;</span>, [-10, 10], 0)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/speed&quot;</span>, [-50, 50], 0, 0)</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    problem.setControlInfo(<span class="stringliteral">&quot;/tau0&quot;</span>, [-100, 100])</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    problem.setControlInfo(<span class="stringliteral">&quot;/tau1&quot;</span>, [-100, 100])</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="comment"># Cost: minimize final time and error from desired</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="comment">#       end effector position.</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    ftCost = osim.MocoFinalTimeGoal()</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    ftCost.setWeight(0.001)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    problem.addGoal(ftCost)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    finalCost = osim.MocoMarkerFinalGoal()</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    finalCost.setName(<span class="stringliteral">&quot;final&quot;</span>)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    finalCost.setWeight(1000.0)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    finalCost.setPointName(<span class="stringliteral">&quot;/markerset/m1&quot;</span>)</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    finalCost.setReferenceLocation(osim.Vec3(0, 2, 0))</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    problem.addGoal(finalCost)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="comment"># Configure the solver.</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    solver = study.initTropterSolver()</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    solver.set_num_mesh_intervals(100)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    solver.set_verbosity(2)</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    solver.set_optim_solver(<span class="stringliteral">&quot;ipopt&quot;</span>)</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160; </div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    guess = solver.createGuess()</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    guess.setNumTimes(2)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    guess.setTime([0, 1])</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    guess.setState(<span class="stringliteral">&quot;/jointset/j0/q0/value&quot;</span>, [0, -math.pi])</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    guess.setState(<span class="stringliteral">&quot;/jointset/j1/q1/value&quot;</span>, [0, 2*math.pi])</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    guess.setState(<span class="stringliteral">&quot;/jointset/j0/q0/speed&quot;</span>, [0, 0])</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    guess.setState(<span class="stringliteral">&quot;/jointset/j1/q1/speed&quot;</span>, [0, 0])</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    guess.setControl(<span class="stringliteral">&quot;/tau0&quot;</span>, [0, 0])</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    guess.setControl(<span class="stringliteral">&quot;/tau1&quot;</span>, [0, 0])</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    guess.resampleWithNumTimes(10)</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    solver.setGuess(guess)</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160; </div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="comment"># Save the problem to a setup file for reference.</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    study.printToXML(<span class="stringliteral">&quot;examplePredictAndTrack_predict.omoco&quot;</span>)</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160; </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="comment"># Solve the problem.</span></div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    solution = study.solve()</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    solution.write(<span class="stringliteral">&quot;examplePredictAndTrack_predict_solution.sto&quot;</span>)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keywordflow">if</span> visualize:</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        study.visualize(solution)</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keywordflow">return</span> solution</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="keyword">def </span>computeMarkersReference(predictedSolution):</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    model = createDoublePendulumModel()</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    model.initSystem()</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    states = predictedSolution.exportToStatesTable()</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160; </div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    statesTraj = osim.StatesTrajectory.createFromStatesTable(model, states)</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    </div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    markerTrajectories = osim.TimeSeriesTableVec3()</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    markerTrajectories.setColumnLabels([<span class="stringliteral">&quot;/markerset/m0&quot;</span>, <span class="stringliteral">&quot;/markerset/m1&quot;</span>])</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160; </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keywordflow">for</span> state <span class="keywordflow">in</span> statesTraj:</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        model.realizePosition(state)</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        m0 = model.getComponent(<span class="stringliteral">&quot;markerset/m0&quot;</span>)</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        m1 = model.getComponent(<span class="stringliteral">&quot;markerset/m1&quot;</span>)</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        markerTrajectories.appendRow(state.getTime(),</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            osim.RowVectorVec3([m0.getLocationInGround(state),</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                                  m1.getLocationInGround(state)]))</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                                  </div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="comment"># Assign a weight to each marker.</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    markerWeights = osim.SetMarkerWeights()</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    markerWeights.cloneAndAppend(osim.MarkerWeight(<span class="stringliteral">&quot;/markerset/m0&quot;</span>, 1))</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    markerWeights.cloneAndAppend(osim.MarkerWeight(<span class="stringliteral">&quot;/markerset/m1&quot;</span>, 5))</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    </div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keywordflow">return</span> osim.MarkersReference(markerTrajectories, markerWeights)</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    </div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="keyword">def </span>solveStateTracking(stateRef):</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="comment"># Predict the optimal trajectory for a minimum time swing-up.</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    study = osim.MocoStudy()</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    study.setName(<span class="stringliteral">&quot;double_pendulum_track&quot;</span>)</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    problem = study.updProblem()</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="comment"># Model (dynamics).</span></div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    problem.setModel(createDoublePendulumModel())</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160; </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="comment"># Bounds.</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <span class="comment"># Arguments are name, [lower bound, upper bound],</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="comment">#                     initial [lower bound, upper bound],</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <span class="comment">#                     final [lower bound, upper bound].</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    finalTime = stateRef.getIndependentColumn()[-1]</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    problem.setTimeBounds(0, finalTime)</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/value&quot;</span>, [-10, 10], 0)</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/speed&quot;</span>, [-50, 50], 0)</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/value&quot;</span>, [-10, 10], 0)</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/speed&quot;</span>, [-50, 50], 0)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    problem.setControlInfo(<span class="stringliteral">&quot;/tau0&quot;</span>, [-150, 150])</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    problem.setControlInfo(<span class="stringliteral">&quot;/tau1&quot;</span>, [-150, 150])</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160; </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="comment"># Cost: track provided state data.</span></div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    stateTracking = osim.MocoStateTrackingGoal()</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    stateTracking.setReference(osim.TableProcessor(stateRef))</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    problem.addGoal(stateTracking)</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160; </div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    effort = osim.MocoControlGoal()</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    effort.setName(<span class="stringliteral">&quot;effort&quot;</span>)</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    effort.setWeight(0.001)</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="comment"># TODO problem.addGoal(effort)</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160; </div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <span class="comment"># Configure the solver.</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    solver = study.initTropterSolver()</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    solver.set_num_mesh_intervals(50)</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    solver.set_verbosity(2)</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    solver.set_optim_solver(<span class="stringliteral">&quot;ipopt&quot;</span>)</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    solver.set_optim_jacobian_approximation(<span class="stringliteral">&quot;exact&quot;</span>)</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    solver.set_optim_hessian_approximation(<span class="stringliteral">&quot;exact&quot;</span>)</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    solver.set_exact_hessian_block_sparsity_mode(<span class="stringliteral">&quot;dense&quot;</span>)</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160; </div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="comment"># Save the problem to a setup file for reference.</span></div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    study.printToXML(<span class="stringliteral">&quot;examplePredictAndTrack_track_states.omoco&quot;</span>)</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160; </div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <span class="comment"># Solve the problem.</span></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    solution = study.solve()</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160; </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    solution.write(<span class="stringliteral">&quot;examplePredictAndTrack_track_states_solution.sto&quot;</span>)</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keywordflow">if</span> visualize:</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        study.visualize(solution)</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keywordflow">return</span> solution</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160; </div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    </div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="keyword">def </span>solveMarkerTracking(markersRef, guess):</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    <span class="comment"># Predict the optimal trajectory for a minimum time swing-up.</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    study = osim.MocoStudy()</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    study.setName(<span class="stringliteral">&quot;double_pendulum_track&quot;</span>)</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160; </div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    problem = study.updProblem()</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160; </div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="comment"># Model (dynamics).</span></div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    problem.setModel(createDoublePendulumModel())</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160; </div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <span class="comment"># Bounds.</span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="comment"># Arguments are name, [lower bound, upper bound],</span></div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="comment">#                     initial [lower bound, upper bound],</span></div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <span class="comment">#                     final [lower bound, upper bound].</span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    finalTime = markersRef.getMarkerTable().getIndependentColumn()[-1]</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    problem.setTimeBounds(0, finalTime)</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/value&quot;</span>, [-10, 10], 0)</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j0/q0/speed&quot;</span>, [-50, 50], 0)</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/value&quot;</span>, [-10, 10], 0)</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/j1/q1/speed&quot;</span>, [-50, 50], 0)</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    problem.setControlInfo(<span class="stringliteral">&quot;/tau0&quot;</span>, [-100, 100])</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    problem.setControlInfo(<span class="stringliteral">&quot;/tau1&quot;</span>, [-100, 100])</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160; </div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="comment"># Cost: track provided marker data.</span></div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    markerTracking = osim.MocoMarkerTrackingGoal()</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    markerTracking.setMarkersReference(markersRef)</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    problem.addGoal(markerTracking)</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    </div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    effort = osim.MocoControlGoal()</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    effort.setName(<span class="stringliteral">&quot;effort&quot;</span>)</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    effort.setWeight(0.0001)</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="comment"># problem.addGoal(effort)</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160; </div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="comment"># Configure the solver.</span></div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    solver = study.initTropterSolver()</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    solver.set_num_mesh_intervals(50)</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    solver.set_verbosity(2)</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    solver.set_optim_solver(<span class="stringliteral">&quot;ipopt&quot;</span>)</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    solver.set_optim_jacobian_approximation(<span class="stringliteral">&quot;exact&quot;</span>)</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    solver.set_optim_hessian_approximation(<span class="stringliteral">&quot;exact&quot;</span>)</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    solver.set_exact_hessian_block_sparsity_mode(<span class="stringliteral">&quot;dense&quot;</span>)</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    </div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    solver.setGuess(guess)</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160; </div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="comment"># Save the problem to a setup file for reference.</span></div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    study.printToXML(<span class="stringliteral">&quot;examplePredictAndTrack_track_markers.omoco&quot;</span>)</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160; </div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    <span class="comment"># Solve the problem.</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    solution = study.solve()</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160; </div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    solution.write(<span class="stringliteral">&quot;examplePredictAndTrack_track_markers_solution.sto&quot;</span>)</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160; </div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <span class="keywordflow">if</span> visualize:</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        study.visualize(solution)</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keywordflow">return</span> solution</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    </div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160; </div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    </div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    </div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;optimalTrajectory = solvePrediction()</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160; </div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;markersRef = computeMarkersReference(optimalTrajectory)</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160; </div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;trackedSolution = solveStateTracking(optimalTrajectory.exportToStatesTable())</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160; </div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;trackedSolution2 = solveMarkerTracking(markersRef, trackedSolution)</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160; </div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160; </div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160; </div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160; </div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160; </div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160; </div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160; </div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160; </div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160; </div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160; </div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160; </div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160; </div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160; </div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160; </div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160; </div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160; </div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
